#include <fstream.h>
#include <ctype.h>
#include <string.h>

ifstream IN;
int Run;
int Result;
int Operators;
int Operator[100];
char Expression[100];
int Position;
bool Solvable;

void Input()
{
  IN >> Result;
  if (Result == 0) return;
  while (IN.peek()==' ' || IN.peek()=='=') IN.get();
  IN.getline(Expression,80);
  for (int i=0; i<(int)strlen(Expression); i++) {
    if (Expression[i]==' ' && (Expression[i+1]==' ' || Expression[i+1]==0 || Expression[i+1]==')' || (i>0 && Expression[i-1]=='('))) {
      memmove(&Expression[i],&Expression[i+1],79-i);
      i--;
    } else if (Expression[i]==')' && Expression[i+1]=='(') {
      memmove(&Expression[i+2],&Expression[i+1],78-i);
      Expression[i+1] = ' ';
    }
  }
  Operators = 0;
  for (int i=0; i<(int)strlen(Expression); i++)
    if (Expression[i] == ' ') {
      Operator[Operators] = i;
      Operators++;
    }
}

void SetOperators(int Try)
{
  for (int i=0; i<Operators; i++) {
    switch (Try % 3) {
      case 0: Expression[Operator[i]] = '+'; break;
      case 1: Expression[Operator[i]] = '-'; break;
      case 2: Expression[Operator[i]] = '*'; break;
    }
    Try /= 3;
  }
}

int EvaluateExpr();

int EvaluateTerm()
{
  int Value = 0;
  if (isdigit(Expression[Position])) {
    do {
      Value = Value*10 + Expression[Position]-'0';
      Position++;
    } while (isdigit(Expression[Position]));
  } else {
    Position++;
    Value = EvaluateExpr();
    Position++;
  }
  return Value;
}

int EvaluateExpr()
{
  int Value = EvaluateTerm();
  while (Expression[Position]=='+' || Expression[Position]=='-' || Expression[Position]=='*') {
    char c = Expression[Position];
    Position++;
    int Value2 = EvaluateTerm();
    if (c == '+') Value += Value2;
    else if (c == '-') Value -= Value2;
    else Value *= Value2;
  }
  return Value;
}

void Output()
{
  cout << "Equation #" << Run << ":" << endl;
  if (Solvable) cout << Result << "=" << Expression << endl;
           else cout << "Impossible" << endl;
  cout << endl;
}

int main()
{
  IN.open("dreisam.in");
  for (Run=1; true; Run++) {
    Input();
    Solvable = false;
    if (Result == 0) break;
    int Possibilities = 1;
    for (int i=0; i<Operators; i++) Possibilities *= 3;
    for (int Try=0; Try<Possibilities; Try++) {
      SetOperators(Try);
      Position = 0;
      int Value = EvaluateExpr();
      // cout << Expression << ": " << Value << " " << Result << endl;
      if (Value == Result) {
        Solvable = true;
        break;
      }
    }
    Output();
  }
  IN.close();
  return 0;
}
