#include <fstream.h>

ifstream IN;
int Run;
int Matrix[80][80];
int Value[80][80];
int Width,Height;
int StartX,StartY,DestX,DestY;

void Input()
{
  IN >> Width >> Height;
  if (Width==0 && Height==0) return;
  char c;
  do {
    c = IN.get();
  } while (c != '\n');
  for (int x=0; x<80; x++) for (int y=0; y<80; y++) Matrix[x][y] = 0;
  for (int y=1; y<=Height; y++) {
    char Line[80];
    for (int i=0; i<80; i++) Line[i] = 0;
    IN.getline(Line,75);
    for (int x=1; x<80; x++) if (Line[x-1] == 'X') Matrix[x][y] = 1;
  }
}

void Expand(int X,int Y)
{
  if ((X!=StartX || Y!=StartY) && Matrix[X][Y]==1) return;
  // cout << "Expanding " << X << "/" << Y << " (Wert " << Value[X][Y] << ")" << endl;
  for (int x=X-1; x>=0; x--) {
    if (Value[X][Y]+1 > Value[x][Y]) break;
    if (Value[X][Y]+1 < Value[x][Y]) {
      Value[x][Y] = Value[X][Y]+1;
      Expand(x,Y);
    }
    if (Matrix[x][Y] == 1) break;
  } 
  for (int x=X+1; x<=Width+1; x++) {
    if (Value[X][Y]+1 > Value[x][Y]) break;
    if (Value[X][Y]+1 < Value[x][Y]) {
      Value[x][Y] = Value[X][Y]+1;
      Expand(x,Y);
    }
    if (Matrix[x][Y] == 1) break;
  } 
  for (int y=Y-1; y>=0; y--) {
    if (Value[X][Y]+1 > Value[X][y]) break;
    if (Value[X][Y]+1 < Value[X][y]) {
      Value[X][y] = Value[X][Y]+1;
      Expand(X,y);
    }
    if (Matrix[X][y] == 1) break;
  } 
  for (int y=Y+1; y<=Height+1; y++) {
    if (Value[X][Y]+1 > Value[X][y]) break;
    if (Value[X][Y]+1 < Value[X][y]) {
      Value[X][y] = Value[X][Y]+1;
      Expand(X,y);
    }
    if (Matrix[X][y] == 1) break;
  } 
}

void Output()
{
  /* for (int y=0; y<Height+2; y++) {
    for (int x=0; x<Width+2; x++) cout << Matrix[x][y];
    cout << endl;
  } */
  cout << "Board #" << Run << ":" << endl;
  for (int Pair=1; true; Pair++) {
    IN >> StartX >> StartY >> DestX >> DestY;
    if (StartX==0 && StartY==0 && DestX==0 && DestY==0) break;
    for (int x=0; x<80; x++) for (int y=0; y<80; y++) Value[x][y] = 1000000;
    Value[StartX][StartY] = 0;
    Expand(StartX,StartY);
    cout << "Pair " << Pair << ": ";
    if (Value[DestX][DestY] == 1000000) {
      cout << "impossible." << endl;
    } else {
      cout << Value[DestX][DestY] << " segments." << endl;
    }
  }
  cout << endl; 
}

int main()
{
  IN.open("game.in");
  for (Run=1; true; Run++) {
    Input();
    if (Width==0 && Height==0) break;
    Output();
  }
  IN.close();
  return 0;
}
